#!c:\perl\bin\perl.exe

#---include section-----------------------------------------------------------------

use LWP::Simple;			# easy way to fetch files from web
use LWP::UserAgent;			# used to fetch and parse files from web
use HTML::Parse;
use HTML::FormatText;
use HTML::LinkExtor;		# used to extract linx
use URI::URL;

#---data section--------------------------------------------------------------------

$ua = new LWP::UserAgent;

  $DATAPATH   = '';                        	# path to data (relative to this script)
  $cfgfile    = 'ano.cfg';
  my @imgs = ();

#-code section----------------------------------------------------------------------


# first of all, check the profiles
open (in, "<$cfgfile");
while (<in>) {
	if ($_ =~ /^profile=(.*)/i) {
		push (@profiles, $1);
	}
}
close (in);

if (@profiles) {
foreach $profile (@profiles) {
		@imgs=();$links2dload= 0;
		# here comes the code of the cfg file parser.
		@triggers=();
		$trig=0;$i=0;$c1=$c2=$c3=$c4=$c5=$c6=0;
		print "Profile name: $profile\n";
		open (in, "<$cfgfile");
		while (<in>) {
			if ($_ =~ /^$profile-main=(.*)/i) {
				print "Main address: $1\n";
				$url=$1;
				$c1++;
			}
			if ($_ =~ /^$profile-mask=(.*)/i) {
				print "Mask address: $1\n";
				$forumadr=$1;
				$c2++;
			}
			if ($_ =~ /^$profile-post=(.*)/i) {
				print "Mb post addr: $1\n";
				$boardnum=$1;
				$c3++;
			}
			if ($_ =~ /^$profile-datafname=(.*)/i) {
				print "Msg filename: $1\n";
				$DATAFNAME=$1;
				$c4++;
			}
			if ($_ =~ /^$profile-triggers-end$/i) {
				$trig=0;
				if (@triggers) {
					foreach $trigger (@triggers) {
						$i++;
						print "Trigger n. $i: $trigger\n";
					}
				}
				$c5++;
			}
			if ($trig) {
				chop;
				push (@triggers, $_);
			}			
			if ($_ =~ /^$profile-triggers-begin$/i) {
				$trig=1;
			}
			if ($_ =~ /^$profile-dloaded=(.*)/i) {
				print "Dld filename: $1\n";
				$dldfname=$1;
				$c6++;
			}
		} #end while (<in>)
			$tot=$c1*$c2*$c3*$c4*$c5*$c6;
		if ($tot) {
			print "Profile $profile is ok: proceeding with the download...\n";

  # Make the parser.  Unfortunately, we don't know the base yet
  # (it might be diffent from $url)
  # Questo perche' il parsing vero e proprio lo facciamo solo dopo,
  # quando ci colleghiamo e recuperiamo l'url

  			$p = HTML::LinkExtor->new(\&callback);

  # Request document and parse it as it arrives
			$res = $ua->request(HTTP::Request->new(GET => $url), sub {$p->parse($_[0])});

  # Expand all image URLs to absolute ones
			my $base = $res->base;
			@imgs = map { $_ = url($_, $base)->abs; } @imgs;

			print "Messages to dload: $links2dload\n";
			$k=0;
		  	foreach $adr (@imgs) {
		  		$k++;
				# put the code to process the "right" addresses now
				save_message ($adr);
				print "Saved [$k/$links2dload]: $adr\n";
			}
		}
		else {
			print "Parameter(s) missing or wrong in profile $profile.\n\n";
		}
} #end foreach $profile
} #end if @profiles
else {
	print "No active profiles found.\n";
}


  # Set up a callback that collects the right links
  # La procedura di callback dev'essere chiamata quando creo un
  # nuovo HTML::LinkExtor

  sub callback {
    my($tag, %attr) = @_;

	$adr=$attr{"href"};						#this is just for anchor tags
	return if $adr !~ /\Q$forumadr/i;		#keep only the addresses related to 
											#the forum
	open(in, "<$dldfname");					#check if the addresses have been
											#dloaded yet
	while(<in>) {
		chop;
		if ($_ =~ /^\Q$adr/i) {
			close (in);
			return;
		}
	}
	push(@imgs, values %attr);
	$links2dload++;
  }


sub save_message{
	$msgurl=shift;
	$msgurl =~ /MyNum=(\d*).*TL=(\d*)/i;
	$msgnumber = $1;
	$msgtopic  = $2;
	my @messages=();
 	my $here=$DATAPATH?$DATAPATH:'.';
 	$DATAFNAME=~/^(.*)(\.\w+)$/;
 	my ($prefix,$suffix)=($1,$2);

 	if (opendir DATADIR, $here){
  		@messages = sort grep/^$prefix\d\d\d$suffix$/, readdir DATADIR;
  		closedir DATADIR
	}
	$msgcount=0;
	if (@messages) {
  		foreach $message (@messages){
			$msgcount++;
  		}
	}
	$msgcount++;
	my $datname=msgfile($msgcount);
	$httpres=getstore($msgurl,"tmp.msg");

	open(in, "<tmp.msg");

	$skrivi=1;$i=0;
	while(<in>) {
		if ($skrivi) {
			# save date
			if ($_ =~ /<FONT SIZE="-1">(.*)<\/FONT>/i) {
				($weekday, $fulldate, $time)=split(/ /,$1);
				$fulldate=~s/-/ /ig;
				$msgdate=substr($weekday,0,3).", ".$fulldate." ".$time;
			}

			# save subj
			if ($_ =~ /<B>(.*)<\/B><br>/i) {
				$msgsubj=$1;
			}

			# save address
			if ($_ =~ /<A HREF="mailto:(.*)"><font/i) {
				$msgadr=$1;
			}

			# save sender
			if ($_ =~ /<font size="-1" face="arial,helvetica">(.*)<\/font>/i) {
				$msgsender=$1;
			}
		}
		if ($_ =~ /^\Q$triggers[$i]/i){
			$skrivi=($skrivi+1) % 2;
			$i++;
		}
	}
	close (in);

	open(out, ">$datname");
	print out "Date: $msgdate +0200\n";
	print out "From: $msgsender <$msgadr>\n";
	print out "Reply-to: $msgtopic-$msgnumber\@$boardnum\n";
	print out "Subject: [$msgtopic-$msgnumber] $msgsubj\n";
	print out "X-Mailer: +Ma's ANO\n";
	print out "X-Profilename: $profile\n";
	print out "Mime-Version: 1.0\n";
	$boundary=$msgtopic."_".$msgnumber;
	print out 'Content-Type: Multipart/related; boundary="'.$boundary.'"';
	print out "\n\n--$boundary-\n";
	print out 'Content-Type: text/html; charset="us-ascii"',"\n\n";

	$msgsender="";
	$msgadr="";
	$msgsubj="";
	open(in, "<tmp.msg");

	$skrivi=1;$i=0;$testo=0;$html='';
	while(<in>) {
		if ($skrivi) {
			print out $_;
		}
		if ($_ =~ /^\Q$triggers[$i]/i){
			$skrivi=($skrivi+1) % 2;
			$i++;
		}
		if (($skrivi)&&($_ =~ /^<\/ul>$/i)){
			$testo=0;
		}
		if ($testo) {
			$html=$html.$_;
		}
		if (($skrivi)&&($_ =~ /^<ul>$/i)){
			$testo=1;
		}
	}
	close (in);
    $ascii = HTML::FormatText->new->format(parse_html($html));
	print out "\n\n--$boundary-\n";
	print out 'Content-type: text/plain; charset="us-ascii"'."\n\n";
	print out "$ascii\n\n--$boundary--\n";
	close (out);

#			salvataggio del link su file (solo dopo essere stato scaricato)
	open (OUT, ">>$dldfname");
	print OUT "$adr\n";
	close (OUT);

}


#---------------------------------------------------
# msgfile returns the filename for message "n"
#---------------------------------------------------
sub msgfile{
	my $msg=shift;
	my $datname=$DATAFNAME;
	$datname=~/(.*)(\.\w+)$/;

	if ($DATAPATH){
		$datname= $DATAPATH.'/'.$1.substr($msg+1000,-3).$2
	}
	else {
 		$datname= $1.substr($msg+1000,-3).$2
	}
}
