#! c:\perl\bin\perl.exe
# Simple smtp daemon
use IO::Socket;
use HTTP::Request::Common;
use LWP::UserAgent;

$\="\r\n"; # output line delimiter

# listen on the well-known smtp port
my $port = 1025;

$hostname= "sally";
$postaddr= "http://post.InsideTheWeb.com/messageboard/post.cgi";
#$postaddr= "http://localhost/cgi-bin/post.cgi";

# create a server socket to listen for
# connections
$sock = new IO::Socket::INET (LocalPort => $port,
                       Proto => 'tcp',
                              Listen => 5,
                              Reuse => 1) ||
     die "Socket error:  $!\n" unless $sock;

print "SMTP server started.\n";

# listen for connections
# don't disconnect after the first connection
# just keep listening

$i=1;
while ($i) {
print "Listening...\n";

# new connection accepted
  $new_sock = $sock->accept();

# get the IP of the client, and the hostname
  $ip = $new_sock->peerhost();
  ($name,$alias,$addrtype,$length,$new_addr) =
      gethostbyaddr(inet_aton($ip),AF_INET);

# print some datas to the screen

  ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime();
  print "*****************************************************************";
  print "[$mday-",$mon+1,"-",1900+$year," $hour:$min:$sec] Connection from:  $name [$ip]\n";
  print $new_sock "220 MalaSMTPD";


# get the query from the client and display it

parse_command: while (<$new_sock>) {
    chop; chop;
    print $_;
   	/^helo *(.*)/i && do {
		$claim=$1;
                print $new_sock "250 $hostname Hello $claim, pleased to meet you";
		next parse_command;
	};
	/^mail from:\s*(.*)/i && do {
		$from=$1;
		$from =~ /"*(.*)"*\s*<(.*)>/;
		print $new_sock "250 $from... Sender ok";
		$fromname=$1;
		$fromadr =$2;
		next parse_command;
	};
	/^noop/ && do {
		print $new_sock "200 OK";
		next parse_command;
	};
	/^quit/i && do {
		print $new_sock "221 $hostname closing connection";
		close ($new_sock);
		last;
	};
	/^rset/i && do {
		print $new_sock '250 Reset state';
		next parse_command;
	};
	s/^rcpt to: *(.*)/\1/i && do {
		s/^.*<([^>]*)>.*$/\1/;
		s/@$hostname//;
		$_ =~ /(.*)-(.*)\@(.*)/;
	    $msgtopic =$1;
	    $msgnumber=$2;
	    $boardnum =$3;
		push(@recipients,$_);
		print $new_sock "250 $_... Recipient ok";
		next parse_command;
	};
	/^data/i && do {

		#variable initialization
		$data=$msgnumber=$pi=$subject=$fromname=$fromadr=$boardnum=$msgtopic='';

		if ($from eq '') {
			print $new_sock '503 Need MAIL command';
			next parse_command;
		};
		if ($#recipients < 0) {
			print $new_sock '503 Need RCPT (recipient)';
			next parse_command;
		}
	    
        $\="\n"; # output line delimiter
        print $new_sock '354 Enter mail, end with "." on a line by itself';
	$header=1;
        while (<$new_sock>) {
		    chop;chop;
#        print $_;
		    if ($header){
				/.+/ || do {
			    	$header=0;
			    	next;
				};
				/^From:\s*(.*)\s+<?(.*)>?/ && do {
				    $fromname=$1;
		    		$fromadr =$2;
					#strip quotes from name
					if ($fromname =~ /"+(.*)"+/) {
						$fromname = $1;
					};
					#strip cket from adr
					if ($fromadr =~ /(.*)>+/) {
						$fromadr = $1;
					};
				    next;
				};
				/^Subject:\s*(.*)/ && do {
				    $subject=$1;
			    	next;
				};
				/^To:\s*(.*)-(.*)\@(.*)/ && do {
				    $msgtopic =$1;
				    $msgnumber=$2;
		    		$boardnum =$3;
				    next;
				};
	    	} #end if
		    else {
				/^\.$/ && do {
    		        $\="\r\n"; # output line delimiter

					# INSERT THE CODE TO POST THE MESSAGE _HERE_!!!
					$data =~ /\n\n(.*)/s;
					if ($msgnumber==0) {$pi="No"} else {$pi='Yes'};
	  				$ua = LWP::UserAgent->new;
  					$response=$ua->request(POST $postaddr, 
	  					[function => "write",
  						 MyNum    => $msgnumber,
  						 P        => $pi,
  						 AdNo     => "0",
	  					 Subject  => $subject,
		  				 name     => $fromname,
  						 email_addr=>$fromadr,
  						 Msg      => $data,
  						 acct     => $boardnum,
  						 TL       => $msgtopic]);
					if ($response->is_success) {
					    print $new_sock '250 Mail accepted';
#						print "Data:\n$data";
	    			    $#recipients = 0;
		    		    $from = '';
	            		next parse_command;
					}
					else{
						die "500 cannot send data to /bin/mail\r\n221 $hostname stopped";
					}
				};
				$data=$data.$_."\n";
	    	}#end else
        }#end while
    };
    print $new_sock "500 command unrecognized";
}; #End of "while new_sock"

($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime();
print "\n[$mday-",$mon+1,"-",1900+$year," $hour:$min:$sec] $name [$ip] disconnected.";
print "*****************************************************************\n";

}; #End of "while $i"

#FORM ACTION="http://post.InsideTheWeb.com/messageboard/post.cgi" METHOD="post"
#function VALUE="write"
#MyNum VALUE="948906082" (messaggio a cui si risponde)     --> TO:msgnumber
#P VALUE="Yes" ???  --> "No" solo se non e' una reply, cioe' Mynum=0 && TL=""
#AdNo VALUE="948907075" (pubblicita' numero... ehehe giochiamo con questa ;)
#Subject TYPE="text" VALUE="Re: Re: Omia2000 e dintorni!" SIZE="44" -->Subj
#name TYPE="text" SIZE=44  --> From:
#email_addr TYPE="text" SIZE=44  --> From: <>
#Msg WRAP=virtual ROWS=10 COLS=49  --> Data:
#acct VALUE="mb962637" (numero della messageboard)  -->TO: (boardnum)
#TL value="948826424" (thread) -->TO:msgtopic
